program BartTool;
{$apptype console}
uses trunit2,sysutils;

var

a,b:ttrlevel;
name1,name2:string;
m,x,k:integer;
i:titem2;
color:word;

oldd,newd:integer;
continuar:boolean;
//-------
funcion,subfuncion:byte;
fd1:byte;
fd2:word;
flag:boolean;
operando,operando1,operando2:word;
bandera:byte;
aux:word;
fixthis:integer;
amount_pages,page_start:integer;
tabla: array [0..3999] of word;
textura:tobjtexture2;
ofset:integer;

room1,room2:integer;
param1,param2,param3,param4,param5,param6:integer;
zfunction:integer;

begin
   Writeln('Bart tool, by TPascal, V 1.0 March 2001');
   writeln;
   writeln('Some nice tools for TR levels');
   Writeln('Type BartTool /h for get full info.');
   Writeln;

   if (paramcount()=0) or (uppercase(paramstr(1))='/H') then
   begin
       writeln('Sintax: BartTool filename /<function>  From_Room To_Room');
       writeln;
       Writeln('<functions> availibles are:');
       writeln('/Info = get level info');
       writeln('/Step_sound  <floorSoundId> = replace floor sound ids. (0-3)');
       writeln('/Lara_Light <newlaralight> = change Lara light 0-31');
       writeln('/Sky  0/1  = enable/disable sky');
       writeln('/Water 0/1 = enable/disable water');
       writeln('/QuickSand 0/1 = enable/disable quicksand');
       writeln('/Textures <oldtextid> <newtextid> = Change textures ids');
       writeln('/ShowItems = Show ItemsId used in level');
       writeln('/Showstatics = Show Statics Mesh id used in levels');
       writeln('/ShowAnimtext = Show animated textures table');
       writeln;
       writeln('If rooms range is not especified all rooms are assumed.');
       halt;
   end;

   name1:=paramstr(1);
   if not fileExists(name1) then
   begin
       writeln(name1,' not found.');
       halt;
   end;

    a:=ttrlevel.create;

zfunction:=0;
if uppercase(paramstr(2))='/INFO' THEN zfunction:=1;
if uppercase(paramstr(2))='/STEP_SOUND' THEN zfunction:=2;
if uppercase(paramstr(2))='/LARA_LIGHT' THEN zfunction:=3;
if uppercase(paramstr(2))='/WATER' THEN zfunction:=4;
if uppercase(paramstr(2))='/SKY' THEN zfunction:=5;
if uppercase(paramstr(2))='/QUICKSAND' THEN zfunction:=6;
if uppercase(paramstr(2))='/TEXTURES' THEN zfunction:=7;
if uppercase(paramstr(2))='/SHOWITEMS' THEN zfunction:=8;
if uppercase(paramstr(2))='/SHOWSTATICS' THEN zfunction:=9;
if uppercase(paramstr(2))='/SHOWANIMTEXT' THEN zfunction:=10;


Case zfunction of
1: // INFO':
Begin
  writeln('Loading Level...');
  if a.Load_level(name1)<>0 then begin Writeln('Invalid tr level format.');halt;end;
  if a.tipo<vtr2 then writeln('Level Version: TR1');
  if (a.tipo=vtr2) or (a.tipo=vtrg) then writeln('Level Version: TR2');
  if a.tipo=vtr3 then writeln('Level Version: TR3');
  if a.tipo=vtr4 then writeln('Level Version: TR4');
  if a.tipo=vtr5 then writeln('Level Version: TR5');

  Writeln('Total Rooms:',a.num_rooms);
  Writeln('Total Textures pages:',a.num_texture_pages);
  Writeln('Total Textures:',a.num_textures);
  Writeln('Total Animated Textures:',a.anim_textures[0]);
  Writeln('Total Items:',a.num_items);
  Writeln('Total Cameras:',a.num_cameras);
  Writeln('Total Boxes:',a.num_boxes);
  Writeln('Total Overlaps:',a.num_overlaps);
  Writeln('Counting vertices & polygons, statics & lights...');
  param1:=0;param2:=0;param3:=0;
  for x:=0 to a.num_rooms-1 do
  begin
      if a.rooms[x].vertices.num_vertices>param1 then param1:=a.rooms[x].vertices.num_vertices;
      if a.rooms[x].quads.num_quads>param2 then param2:=a.rooms[x].quads.num_quads;
      if a.rooms[x].triangles.num_triangles>param3 then param3:=a.rooms[x].triangles.num_triangles;
      m:=m+a.rooms[x].statics.num_static;
      k:=k+a.rooms[x].source_lights.num_sources;

  end; //end go all rooms
  Writeln('Total Statics meshes:',m);
  Writeln('Total spots lights   :',k);
  Writeln('Maximum Vertices used:',param1);
  Writeln('Maximum Rectangles used:',param2);
  Writeln('Maximum Triangles used:',param3);
  for k:=0 to a.num_items-1 do
    begin
        if a.items2[k].obj=0 then param1:=a.items2[k].room;
     end;
  Writeln('Lara start a room:',param1);
  writeln;
  writeln('Done.');
end; //en case /info.


2: //Step Sound
begin

  if paramstr(3)<>'' then aux:=strtoint(paramstr(3)) else begin writeln('Missing parameter');halt;end;
  writeln('Loading Level...');
  if a.Load_level(name1)<>0 then begin Writeln('Invalid tr level format.');halt;end;
  if a.tipo<vtr3 then begin writeln('Function Only for Tr3 and above version');halt;end;

  writeln('Changing Floor Sound...');
  param2:=0;
  param3:=a.num_rooms-1;

  if paramstr(4)<>'' then param2:=strtoint(paramstr(4));
  if paramstr(5)<>'' then param3:=strtoint(paramstr(5));

  if param3>(a.num_rooms-1) then param3:=(a.num_rooms-1);
  if param3<param2 then param3:=param2;


  if aux>15 then aux:=5;

  if aux=0 then aux:=5;
  if aux=1 then aux:=12;
  if aux=2 then aux:=13;
  if aux=3 then aux:=3;

  for k:=param2 to param3 do
  begin
      for m:=1 to a.rooms[k].sectors.largo*a.rooms[k].sectors.ancho do
      begin
           WORD(a.rooms[k].sectors.sector[m].box_index):=
           WORD(a.rooms[k].sectors.sector[m].box_index) and $fff0;

           WORD(a.rooms[k].sectors.sector[m].box_index):=
           WORD(a.rooms[k].sectors.sector[m].box_index) or aux;
      end;//todos los sectores
   end;//todos los cuartos

  writeln('Saving the level...');
  a.Save_Level(name1);
  Writeln('Done.');

end;//end floor sound


3: //Lara Light
begin

  if paramstr(3)<>'' then aux:=strtoint(paramstr(3)) else begin writeln('Missing parameter');halt;end;

  writeln('Loading Level...');
  if a.Load_level(name1)<>0 then begin Writeln('Invalid tr level format.');halt;end;
  writeln('Changing Lara Light...');
  param2:=0;
  param3:=a.num_rooms-1;

  if paramstr(4)<>'' then param2:=strtoint(paramstr(4));
  if paramstr(5)<>'' then param3:=strtoint(paramstr(5));

  if param3>(a.num_rooms-1) then param3:=(a.num_rooms-1);
  if param3<param2 then param3:=param2;
  for k:=param2 to param3 do
  begin
       a.rooms[k].lara_light:=aux;
       if a.tipo>=vtr4 then
       begin
          move(aux,a.rooms[k].d0,2);
       end;

   end;
  writeln('Saving the level...');
  a.Save_Level(name1);
  Writeln('Done.');

end;//end Lara light


4: //water ON/OFF
begin
  param1:=-1;
  if paramstr(3)<>'' then param1:=strtoint(paramstr(3)) else begin writeln('Please especify 0 or 1');halt;end;

  writeln('Loading Level...');
  if a.Load_level(name1)<>0 then begin Writeln('Invalid tr level format.');halt;end;
  writeln('Turning On/Off the water...');
  param2:=0;
  param3:=a.num_rooms-1;

  if paramstr(4)<>'' then param2:=strtoint(paramstr(4));
  if paramstr(5)<>'' then param3:=strtoint(paramstr(5));

  if param3>(a.num_rooms-1) then param3:=(a.num_rooms-1);
  if param3<param2 then param3:=param2;

  for k:=param2 to param3 do
  begin
     if param1<>0 then
                     a.rooms[k].water:=a.rooms[k].water or 1
                  else
                     a.rooms[k].water:=a.rooms[k].water and 254;
  end;
  writeln('Saving the level...');
  a.Save_Level(name1);
  Writeln('Done.');

end;//end water on/off

5: //Sky ON/OFF
begin
  param1:=-1;
  if paramstr(3)<>'' then param1:=strtoint(paramstr(3)) else begin writeln('Please especify 0 or 1');halt;end;

  writeln('Loading Level...');
  if a.Load_level(name1)<>0 then begin Writeln('Invalid tr level format.');halt;end;
  writeln('Turning On/Off the Sky...');
  param2:=0;
  param3:=a.num_rooms-1;

  if paramstr(4)<>'' then param2:=strtoint(paramstr(4));
  if paramstr(5)<>'' then param3:=strtoint(paramstr(5));

  if param3>(a.num_rooms-1) then param3:=(a.num_rooms-1);
  if param3<param2 then param3:=param2;

  for k:=param2 to param3 do
  begin
     if param1<>0 then
                     a.rooms[k].water:=a.rooms[k].water or 8
                  else
                     a.rooms[k].water:=a.rooms[k].water and 247;
  end;
  writeln('Saving the level...');
  a.Save_Level(name1);
  Writeln('Done.');

end;//end sky on/off

6: //Quicksand ON/OFF
begin
  param1:=-1;
  if paramstr(3)<>'' then param1:=strtoint(paramstr(3)) else begin writeln('Please especify 0 or 1');halt;end;

  writeln('Loading Level...');
  if a.Load_level(name1)<>0 then begin Writeln('Invalid tr level format.');halt;end;
  writeln('Turning On/Off the Quicksand...');
  param2:=0;
  param3:=a.num_rooms-1;

  if paramstr(4)<>'' then param2:=strtoint(paramstr(4));
  if paramstr(5)<>'' then param3:=strtoint(paramstr(5));

  if param3>(a.num_rooms-1) then param3:=(a.num_rooms-1);
  if param3<param2 then param3:=param2;

  for k:=param2 to param3 do
  begin
     if param1<>0 then
                     a.rooms[k].water:=a.rooms[k].water or 128
                  else
                     a.rooms[k].water:=a.rooms[k].water and 127;
  end;
  writeln('Saving the level...');
  a.Save_Level(name1);
  Writeln('Done.');

end;//end quicksand on/off


7: //textures
begin

  if (paramstr(3)<>'') or (paramstr(4)<>'') then aux:=strtoint(paramstr(3)) else begin writeln('Missing parameter');halt;end;
  writeln('Loading Level...');
  if a.Load_level(name1)<>0 then begin Writeln('Invalid tr level format.');halt;end;

  writeln('Changing Textures Ids...');
  param5:=0;
  param6:=a.num_rooms-1;

  if paramstr(5)<>'' then param5:=strtoint(paramstr(5));
  if paramstr(6)<>'' then param6:=strtoint(paramstr(6));

  if param6>(a.num_rooms-1) then param6:=(a.num_rooms-1);
  if param6<param5 then param6:=param5;


  param3:=strtoint(paramstr(3));
  param4:=strtoint(paramstr(4));


  for k:=param5 to param6 do
  begin

      for m:=1 to a.rooms[k].quads.num_quads do
      begin
         if (a.rooms[k].quads.quad[m].texture and $0fff)=param3
         then a.rooms[k].quads.quad[m].texture:=param4;
      end;//todos los quads

      for m:=1 to a.rooms[k].triangles.num_triangles do
      begin
         if a.rooms[k].triangles.triangle[m].texture=param3
         then a.rooms[k].triangles.triangle[m].texture:=param4;
      end;//todos los triangles
   end;//todos los cuartos

  writeln('Saving the level...');
  a.Save_Level(name1);
  Writeln('Done.');

end;//end change textures


8: //SHOWITEMS
begin
  writeln('Loading Level...');
  if a.Load_level(name1)<>0 then begin Writeln('Invalid tr level format.');halt;end;
  writeln('Showing Items Id used in this level:');
  writeln;
  fillchar(tabla[0],1024,0);
  for x:=0 to a.num_Items-1 do
  begin
      if a.tipo<vtr2 then tabla[a.Items[x].obj]:=1 else
         tabla[a.Items2[x].obj]:=1
  end;//find todos los items.
  for x:=0 to 511 do
  begin
      if tabla[x]<>0 then write('ID:',x:3,'  ');
  end;
  writeln;
  writeln('Done.');

end; //end show items;


9: //SHOWSTATICS
begin
  writeln('Loading Level...');
  if a.Load_level(name1)<>0 then begin Writeln('Invalid tr level format.');halt;end;
  writeln('Showing STATICS MESHES Ids used in this level:');
  writeln;
  for x:=0 to a.num_static_table-1 do
  begin
      Write('ID:',a.static_table[x].idobj:3,'  ');
  end;
  writeln;
  writeln('Done.');

end; //end show statics;

10: //SHOWANIMTEXT
begin
  writeln('Loading Level...');
  if a.Load_level(name1)<>0 then begin Writeln('Invalid tr level format.');halt;end;
  writeln('Showing ANIMATED TEXTURES Ids used in this level:');
  writeln;

ofset:=1;
fixthis:=0;

for m:=1 to a.anim_textures[0] do
begin
   x:=a.anim_textures[ofset]+1; //cuantas frames tiene esta textura animada.
   Write('Animated Texture#',m:2,'-->');
   for k:=1 to x do
   begin
       aux:=a.anim_textures[ofset+k];
       write(aux:4,'  ');
   end;
   ofset:=ofset+x+1;
   writeln;
end; //no mas texturas animadas.
writeln('Done.');


end; //end show animated textures;


else
begin
   writeln('Invalid command function, type BartTool /h');
   halt;
end;

END; //end case



end.




