{$apptype console}
PROGRAM VF;
USEs TRUNIT2,sysutils,script,trscript;

var

l:ttrlevel;
name,scpname,newname:string;

begin

writeln('TR Scripting Commands. Version 2.0, Compile a SCP file to a TR level.');
writeln('Programado por TPASCAL, OCT-2001, Tegucigalpa, Honduras.');
writeln;

if (paramcount()<1) or (paramcount()=2) then
 begin
     writeln('Sintax: TRScp EmptyLevel Scriptfile Newlevel');
     writeln;
     writeln('Example: TRScp empty.phd level2.scp level2.phd');
     writeln;
     writeln('Type: TRscp LevelFile');
     writeln('for find out how much Items the level has.');
     halt;
 end;


name:=paramstr(1);
scpname:=paramstr(2);
newname:=paramstr(3);


if not fileExists(name) then
begin
   writeln('File ',name,' Not Found!.');
   Halt;
end;

writeln('Opening the file...');

L:=ttrlevel.create;

if l.load_level(name)<>0 then
begin
    writeln('Error Opening the Level file!.');
    writeln;
    halt;
end;


if paramcount()=1 then
begin
    Writeln('Items used in this level:',l.num_items);
    Writeln('Cameras used in this level:',l.num_cameras);
    halt;
end;


if not fileExists(scpname) then
begin
   writeln('File ',scpname,' Not Found!.');
   Halt;
end;

writeln('Compiling the Commands scripts...');

if apply_scripting(scpname,l)=-1 then
begin
   writeln('Error at line ',scp_linea);
   writeln(error_message);
   halt;
end
else
begin
  l.save_level(newname);
  writeln('Done.');
end;


end.


